package api

import (
	"fmt"

	"github.com/gin-gonic/gin"
)

// RegRouters 注册路由
func RegRouters(svc *Service) {

	r := svc.NewGinRouter("/cmf")

	r.group.Use(Logger())
	// website := r.group.Group("/website")

	// // nav
	// r.POSTJWT("/nav/create", CreateNav)
	// r.POSTJWT("/nav/delete/:id", DeleteNav)
	// r.GETJWT("/nav/list", NavList)
	// r.GETJWT("/nav/detail/:id", NavDetail)
	// r.POSTJWT("/nav/update", UpdateNav)

	// // gallery

	// r.POSTJWT("/gallery/create", CreateGallery)
	// r.POSTJWT("/gallery/delete/:id", DeleteGallery)
	// r.GETJWT("/gallery/list", GalleryList)
	// r.GETJWT("/gallery/detail/:id", GalleryDetail)
	// r.POSTJWT("/gallery/update", UpdateGallery)

	// category
	r.GET("/getToken", callback)
	r.GETJWT("/r1", func(c *gin.Context, apictx *ApiSession) (interface{}, error) {
		return apictx.User, nil
	})

	CreateCategoryRouter(r)
	// Asset(r)
	ModelLib(r)
	// Decorate(r)
	// Scene(r)
	MatLib(r)
	// ArtworkColor(r)
	Shape(r)
	Finish(r)
	MyCaseRoute(r)

	r.GET("/printr", Printr)
}

func Logger() gin.HandlerFunc {

	return func(c *gin.Context) {
		// 开始时间
		// start := time.Now()
		// 处理请求
		c.Next()
		// 结束时间
		// end := time.Now()
		//执行时间
		// latency := end.Sub(start)

		path := c.Request.URL.Path

		clientIP := c.ClientIP()
		// method := c.Request.Method
		// statusCode := c.Writer.Status()

		out := fmt.Sprintf("%15s=> %s", clientIP, path)
		fmt.Println(out)
	}
}
